function [nearestIdx, coordinates] = mykmeansMoje(dataFileName, clusterCount)
% spusteni: [nearestIndx, coordinates] = mykmeansMoje('cv05.data.txt',2);
% nacteni dat z csv file
vectors = csvread(dataFileName);

% initialize centroidu pouzitim nahodne pozice
centroids = selectRandomCentroids(vectors, clusterCount);

% kmeans algoritmus
% nearestIdx - vysledne prirazeni vektoru k jednotlivym centroidum
% coordinates - vysledne pozice centroidu (reprezentantu)
[nearestIdx, coordinates] = mykmeans(vectors, centroids);

% prezentace siluety
silhouette(vectors,nearestIdx,'sqeuclid')

end

% uklada nahodne pozice vektoru, vsechny hodnoty v poli jsou unikatni
function [centroids] = selectRandomCentroids(vectors, clusterCount)
vectorsCount = size(vectors, 1); % zjisti pocet radku data.csv
centroids = zeros(clusterCount, size(vectors, 2));
arrRandomVectorPos = zeros(clusterCount ,1);


% nahodne vybery pozic
% nutno zajistit, aby vsechny pozice vyberu byly unikatni
for i = 1:clusterCount
    isUnique = false;
    while(~isUnique)
        arrRandomVectorPos(i) = randi(vectorsCount);
        isUnique = true;
        for ii = 1:(i - 1)
            if arrRandomVectorPos(i) == arrRandomVectorPos(ii)
                isUnique = false;
            end
        end
    end
end
% copy vectoru do vysledku
for i = 1:clusterCount
    centroids(i,:) = vectors(arrRandomVectorPos(i),:);
end
end